The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::Modulate Class Reference

STK periodic/random modulator. More...

`#include <Modulate.h>`

Inheritance diagram for stk::Modulate:

List of all members.

## Public Member Functions
| Modulate (void)
| Class constructor.
| ~Modulate (void)
| Class destructor.
void | reset (void)
| Reset internal state.
void | setVibratoRate (StkFloat rate)
| Set the periodic (vibrato) rate or frequency in Hz.
void | setVibratoGain (StkFloat gain)
| Set the periodic (vibrato) gain.
void | setRandomGain (StkFloat gain)
| Set the random modulation gain.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (void)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.

## Detailed Description

STK periodic/random modulator.

This class combines random and periodic modulations to give a nice, natural human modulation function.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Constructor & Destructor Documentation

stk::Modulate::Modulate | ( | void |  | ) |

Class constructor.

An StkError can be thrown if the rawwave path is incorrect.

## Member Function Documentation

StkFrames & stk::Modulate::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Generator.

    00090 {
    00091 #if defined(_STK_DEBUG_)
    00092   if ( channel >= frames.channels() ) {
    00093     oStream_ << "Modulate::tick(): channel and StkFrames arguments are incompatible!";
    00094     handleError( StkError::FUNCTION_ARGUMENT );
    00095   }
    00096 #endif
    00097
    00098   StkFloat *samples = &frames[channel];
    00099   unsigned int hop = frames.channels();
    00100   for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
    00101     *samples = Modulate::tick();
    00102
    00103   return frames;
    00104 }

The documentation for this class was generated from the following file:

- Modulate.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.